#include <dos.h>
#include <conio.h>
#include "stuff.h"

void outsl(ushort addr, char *buf, ushort size) {
  ushort* p = (ushort *)buf;
  int i;
  for (i=0; i<size*2; i++) outw(*(p+i), addr);
}

void insl(ushort addr, char *buf, ushort size) {
  ushort* p = (ushort *)buf;
  int i;
  for (i=0; i<size*2; i++) *(p+i)=inw(addr);
}

ushort ntohs(ushort d) {
  ushort x=d;
  uchar* p=(uchar*) &x;
  uchar b=*p;
  *p=*(p+1); *(p+1)=b;
  return x;
}
ushort htons(ushort d) { return ntohs(d); }

void enable_irq(unsigned int irq_nr)
{
  uchar mask, cache;
  mask = ~(1 << (irq_nr & 7));
  cli();
  if (irq_nr < 8)  {
    cache = inb(0x21);
    cache &= mask;
    outb(cache, 0x21);
  }
  else {
    cache = inb(0xa1);
    cache &= mask;
    outb(cache, 0xa1);
  }
  sti();
}

void presmeruj_irq(void)
{
  uchar mask;

  cli();
  mask = inb(0xa1);

  outb(0x00, 0xf1); // reset koprocesoru

  outb(0x13, 0xa0); // ICW1 (potreba ICW4)
  outb(0x70, 0xa1); // ICW2 tabulka v.p.
  outb(0x04, 0xa1); //
  outb(0x01, 0xa1);

  outb(mask, 0xa1); // puvodni maska

  sti();
}
